/* Module font.c
   Do some handlig of fonts that are needed in cgui.

   Calculates the baseline of the font. This may be useful to know e.g. when
   underlining text (for short-cuts in labels)
*/

#include <allegro/internal/aintern.h>

#include "font.h"
#include "fontdata.h"

#if ALLEGRO_SUB_VERSION == 0
#define textout_ex(bmp, f, s, x, y, col, bgcol) textout(bmp, f, s, x, y, col)
#endif

FONT *_cgui_prop_font;
static FONT *cgui_fix_font;
static FONT *orgfont;
int cgui_started;
extern void SetCguiFont(FONT *f);

extern void InitFont(void)
{

   _cgui_prop_font = _cgui_fonts_datafile[_CGUI_FONT].dat;
   cgui_fix_font = _cgui_fonts_datafile[_CGUI_FIX_FONT].dat;
   _cgui_prop_font->vtable = &_font_vtable_mono;
   cgui_fix_font->vtable = &_font_vtable_mono;
   orgfont = _cgui_prop_font;
   SetCguiFont(cgui_fix_font);
}

extern FONT *GetCguiFont(void)
{
   if (!cgui_started)
      InitFont();
   return _cgui_prop_font;
}

extern FONT *GetCguiFixFont(void)
{
   return cgui_fix_font;
}

extern void SetCguiFont(FONT *f)
{
   int base_line;

   if (f == NULL) {
      _cgui_prop_font = orgfont;
   } else {
      _cgui_prop_font = f;
   }

}

